*******************************
* RLNK - Remember Link        *
*  RGF-Software              *
* Autor: Rdiger Solbach      *
* --------------------------- *
* Sprache: Pure C Assembler   *
* Letzte nderung: 2003/11/28 *
*******************************

		.TEXT
start:

; Traps
gemdos		equ		1
bios		equ		13
xbios		equ		14

; Adressen
gemdosvec	equ		$84
_longframe	equ		$059E
etv_term	equ		$408

; Funktionen
supexec		equ		38
ptermres	equ		$31
cconws		equ		9
fsymlink	equ		302
frename		equ		86
fdelete		equ		65

; Rckgabewerte
e_ok		equ		0
einvfn		equ		-32

		bra		los

switch:	dc.w	-1				; Ein-/Ausschalter

		dc.b	'XBRA'			; XBRA
		dc.b	'RLNK'			; Kennung
oldadr:	dc.l	0				; alte Adresse

* neue/alte Funktion
new_trp:
		move.w	switch(pc),d0
		beq		old
		
		btst	#$05,(sp)		; Trap im S-Modus?
		bne		usermode		; nein, usermode
		move	usp,a0			; usp nach a0
lauf:
		move.w	(a0),d0			; Funktionsnummer nach d0
		
		cmpi.w	#fsymlink,d0
		beq		Fsym
		cmpi.w	#fdelete,d0
		beq		Fdel
		cmpi.w	#frename,d0
		beq		Fren
		
		bra		old
Fsym:
		move.l	2(a0),org		; Original Datei
		move.l	6(a0),lnk		; zu erzeugender Link
		
		lea		link,a0
		jsr		output
		
		move.l	org,a0
		lea		(a0),a0
		jsr		output
		lea		spc,a0
		jsr		output
		
		move.l	lnk,a0
		lea		(a0),a0
		jsr		output
		lea		ret,a0
		jsr		output
		
		bra		old
Fdel:
		move.l	2(a0),org		; zu lschende Datei
		
		lea		delete,a0
		jsr		output
		
		move.l	org,a0
		lea		(a0),a0
		jsr		output
		lea		ret,a0
		jsr		output
		
		bra		old
Fren:
		move.l	4(a0),org		; alter Name
		move.l	8(a0),lnk		; neuer Name
		
		lea		rename,a0
		jsr		output
		
		move.l	org,a0
		lea		(a0),a0
		jsr		output
		lea		spc,a0
		jsr		output
		
		move.l	lnk,a0
		lea		(a0),a0
		jsr		output
		lea		ret,a0
		jsr		output
old:
		move.l	oldadr(pc),-(sp); alte Adresse auf Stack
		rts						; und Fertig
		
		dc.b	'XBRA'			; XBRA
		dc.b	'RLNK'			; Kennung
oldadr2:dc.l	0				; alte Adresse
sys_term:
		;move.w	et(pc),d0
		;cmp.w	#0,d0
		;bne		et_ein
		
		lea		etvterm,a0
		jsr		output
		jsr		ping
		
		;bra		et_raus
;et_ein:	move.w	et(pc),a0
		;move.w	#0,(a0)
		;pea		inst_et
		;move	#supexec,-(sp)
		;trap	#xbios
		;addq.l	#6,sp
et_raus:rts

usermode:
		tst.w	_longframe.w	; CPU > 68008 ?
		bne.s	longstack
		lea		$06(sp),a0		; nein
		bra		lauf
longstack:
		lea		$08(sp),a0		; ja
		bra		lauf

; Programmstart
los:
		move.l	4(sp),a6		; Zeiger auf Basepage-Struktur
		move.l	#$100,d0		; Lnge der Basepage
		add.l	$c(a6),d0		; Lnge Text-Segment
		add.l	$14(a6),d0		; Lnge Daten-Segment
		add.l	$1c(a6),d0		; Lnge BSS
		add.l	#$100,d0		; etwas Sicherheit
		move.l	d0,-(sp)		; Ergebnis auf den Stack
		move.l	a6,-(sp)		; Basepage-Adresse auf den Stack
		move.l	44(a6),env		; Adresse Environmentvariablen merken
		clr.w	-(sp)			; Fllparameter
		move.w	#$4a,-(sp)		; GEMDOS Mshrink
		trap	#gemdos			; GEMDOS-Trap
		lea		$c(sp),sp		; Stack aufrumen
				
		lea		info,a0			; Startmeldungen ausgeben
		jsr		output
		lea		autor,a0
		jsr		output
		
		move.w	#25,-(sp)		; Dgetdrv
		trap	#gemdos			; Gemdos
		addq.l	#2,sp			; Korrektur
		; Ergebnis in D0 (0=aktuelles, 1=A, 2=B, 3=C usw..)
		; 0 tritt hoffentlich nicht auf
		
		addq	#1,d0			; da bei Dgetpath 1=A usw
		
		move.w	d0,-(sp)
		pea		path
		move.w	#71,-(sp)		; Dgetpath
		trap	#gemdos			; Gemdos
		addq.l	#8,sp			; Korrektur
		tst		d0
		bne		term
		lea		path,a0
		jsr		output
		
		move.l	env,a4			; Nach Programmname suchen
		subq	#1,a4
env_srch:
		addq	#1,a4
		cmp.l	#"_PNA",(a4)
		beq		get_pn
		cmp.w	#00,(a4)
		bne		env_srch
		
		lea		kein_pn,a0		; Ausgabe: nicht gefunden
		jsr		output
		lea		abbruch,a0
		jsr		output
		bra		term			; Fehler und schluss
		
get_pn:							; gefunden
		addq.l	#6,a4			; Adresse auf name setzen
		move.l	a4,env
		lea.l	test,a5
		move.l	a4,a3
		move.l	test,a2
env_copy:
		move.b	(a4)+,(a5)+
		;cmp.b	#0,(a4)
		tst.b	(a4)
		bne.s	env_copy
		subq	#1,a5
		move.b	#"L",(a5)+		; letzter buchstabe 'L'
		move.b	#0,(a5)+
		
		;move.l	a2,-(sp)		; Test-Link vorher lschen
		;move.w	#65,-(sp)		; man weiss ja nie ;-)
		;trap	#gemdos
		;addq.l	#6,sp

	* Test, ob Fsymlink berhaupt vorhanden
		pea		test
		pea		env
		move.w	#302,-(sp)		; Funktionsnummer
		trap	#gemdos			; gemdos aufrufen
		lea		10(sp),sp		; korrektur
		
		;cmp		#e_ok,d0		; Fehler?
		tst.w	d0
		beq		weiter			; nein
		
		lea		nofunc,a0
		jsr		output
		bra		term
		
weiter:
		pea		test			; Test-Link wieder lschen
		move.w	#fdelete,-(sp)
		trap	#gemdos
		addq.l	#6,sp
		
		pea		install			; Installationsroutine im
		move	#supexec,-(sp)	; Supervisormodus
		trap	#xbios			; aufrufen
		addq.l	#6,sp
		
		tst.w	d0				; installation erfolgreich?
		bmi		term			; nein.. war schon drin
		
		pea		inst_et			; etv_term testweise
		move	#supexec,-(sp)	; auch belegen
		trap	#xbios
		addq.l	#6,sp
		
		lea		success,a0
		jsr		output
		
	; resident beenden
		clr		-(sp)
		move.l	ende,d5
		sub		start,d5
		add		#$100,d5
		move.l	d5,-(sp)
		move	#ptermres,-(sp)
		trap	#gemdos
		; hier ist ende
		
term:	move	#0,-(sp)		; schluss
		trap	#gemdos
		;ende
		
install:
		lea		gemdosvec.w,a0	; Vektor nach a0
		lea		new_trp(pc),a1	; Routinen-Adresse nach a1
		
	* schon installiert?
xbra_srch:
		movea.l	(a0),a2			; Adresse nach a2
		cmpi.l	#'XBRA',-12(a2)	; XBRA ?
		bne.s	ok				; nein, ok installieren
		move.l	-8(a1),d1		; meine Kennung nach d1
		cmp.l	-8(a2),d1		; Vergleiche mit aktueller Kennung
		beq		schon_drin		; stimmt, schon_drin
		lea		-4(a2),a0		; nchste Kette nach a0
		bra		xbra_srch		; und von vorn
		
ok:		lea		gemdosvec.w,a0	; Vektor nach a0
		move.l	(a0),-4(a1)		; alte Adresse merken [-4(a1) = oldadr]
		move.l	a1,(a0)			; und neue eintragen
		
		clr.w	d0				; 0 = neu installation
		rts
		
schon_drin:
		not.w	switch-new_trp(a2); Ein-/Ausschalter bettigen
		beq.s	de				; Meldungen dementsprechend
		lea		success,a0
		jsr		output
		bra.s	w1
de:		lea		deakt,a0
		jsr		output
w1:		moveq	#-1,d0			; -1 = ich war schon drin
		rts
		
inst_et:
		lea		etv_term.w,a0	; etv_term
		lea		sys_term,a1		; belegen
		move.l	(a0),-4(a1)
		move.l	a1,(a0)
		rts
		
output:
	move.l	a0,-(sp)
	move.w	#cconws,-(sp)
	trap	#gemdos
	addq.l	#6,sp
	rts

ping:
		move.w	#7,-(sp)
		move.w	#2,-(sp)
		move.w	#3,-(sp)
		trap	#bios
		addq.l	#6,sp
		rts
		
		
		.DATA
ret:	dc.b	13,10,0
EVEN
spc:	dc.b	32,0
EVEN
info:	dc.b	13,10,27,"p RLNK  ",189," RGF-Software ",13,10,0
EVEN
autor:	dc.b	"Autor: Rdiger Solbach",27,"q",13,10,0
EVEN
nofunc:	dc.b	"Funktion nicht vorhanden!",13,10,0
EVEN
abbruch:dc.b	"Installation wird abgebrochen!",13,10,0
EVEN
kein_pn:dc.b	"Fehler im Environment?",13,10,0
EVEN
success:dc.b	"Installation erfolgreich!",13,10,0
EVEN
deakt:	dc.b	"RLNK ist nun deaktiviert!",13,10,0
EVEN

link:	dc.b	"Fsymlink: ",0
EVEN
delete:	dc.b	"Fdelete: ",0
EVEN
rename:	dc.b	"Frename: ",0
EVEN

etvterm:dc.b	"Ende",0
EVEN
et:		dc.w	-1
EVEN


		.BSS
env:		ds.l	5
test:		ds.l	3
org:		ds.l	1
lnk:		ds.l	1
path:		ds.b	256

ende:	END